#
/*
 * 	MSC data
 */
#
#ifndef	MSC_DECODER
#define	MSC_DECODER

#include	<stdio.h>
#include	<stdint.h>
#include	"audiosink.h"
#include	"deconvolve.h"
#include	<stdio.h>

class	RadioInterface;
class	dabVirtual;

class mscHandler {
public:
		mscHandler		(RadioInterface *,
	                                 audioSink *,
	                                 uint8_t);
		~mscHandler		(void);
	void	process_mscBlock	(int16_t *, int16_t);
	void	setChannel		(int16_t, int16_t, int16_t,
	                                 int16_t, int16_t, int16_t, int16_t,
	                                 int16_t, int16_t);
	uint8_t	getMode			(void);
	int16_t	getChannel		(void);
	int16_t	getLanguage		(void);
	int16_t	getType			(void);
	void	stopProcessing		(void);
	void	setFiles		(FILE *, FILE *);
private:
	bool		concurrencyOn;
	dabVirtual	*dabHandler;
	int16_t		*cifVector;
	int16_t		cifCount;
	int16_t		blkCount;
	RadioInterface	*myRadioInterface;
	int16_t		currentChannel;
	bool		newChannel;
	int16_t		new_startAddr;
	int16_t		new_Length;
	int16_t		new_uepFlag;
	int16_t		new_protLevel;
	int16_t		new_bitRate;
	int16_t		new_language;
	int16_t		new_type;
	int16_t		startAddr;
	int16_t		Length;
	int16_t		uepFlag;
	int16_t		protLevel;
	int16_t		bitRate;
	int8_t		dabModus;
	int8_t		new_dabModus;

	int16_t		blockCount;
	audioSink	*our_audioSink;
	FILE		*mp2File;
	FILE		*mp4File;
};

#endif


