#
#ifndef	OFDM_DECODER_A
#define	OFDM_DECODER_A
/*
 *
 */
#include	"dab-constants.h"
#include	"stdint.h"
#include	"phasereference.h"
#include	"ofdm_decoder.h"
#include	"fic_handler.h"
#include	"msc_handler.h"
#include	"virtual_input.h"
#include	<QThread>
#include	<QObject>
#include	"ringbuffer.h"
#include	"ofdm_processor.h"

class	RadioInterface;
class	common_fft;

class ofdm_processor_a: public ofdm_processor {
Q_OBJECT
public:
		ofdm_processor_a	(virtualInput *,
	                                 uint32_t,
	                                 uint32_t,
	                         	 uint32_t,
	                                 RadioInterface *,
	                                 mscHandler *,
	                                 ficHandler *,
	                                 int16_t,		// fillpoint
	                                 RingBuffer<DSPCOMPLEX> *,
	                                 RingBuffer<DSPCOMPLEX> *,	// passing
	                                 int32_t,		// buffersize
	                                 bool);
		~ofdm_processor_a	(void);
private:
	int32_t		sampleCnt;
	int32_t		inputSize;
	int32_t		inputPointer;
	void		getNextSampleReady	(void);
	DSPCOMPLEX	currentSample;
virtual	void		run		(void);
};
#endif

