#
#ifndef	OFDM_DECODER_B
#define	OFDM_DECODER_B
/*
 *	We made two implementations of the ofdmProcessor,
 *	one with an explicit "state", the other one with
 *	the state of the computation implicit
 *	This happens to be the explicit one
 */
#include	"ofdm_processor.h"

class	RadioInterface;
class	common_fft;

class ofdm_processor_b: public ofdm_processor {
Q_OBJECT
public:
		ofdm_processor_b	(virtualInput *,
	                                 uint32_t,
	                                 uint32_t,
	                                 uint32_t,
	                                 RadioInterface *,
	                                 mscHandler *,
	                                 ficHandler *,
	                                 int16_t,		// fillpoint
	                                 RingBuffer<DSPCOMPLEX> *,
	                                 RingBuffer<DSPCOMPLEX> *, // passing
	                                 int32_t,		// buffersize
	                                 bool);
		~ofdm_processor_b	(void);
private:
virtual	void		run		(void);
	int32_t		syncPhaseIndex;
	uint32_t	syncTries;
	uint32_t	syncCounter;
	int8_t		decoderMode;
};
#endif

